
local deformat = AceLibrary("Deformat-2.0")
local dewdrop = AceLibrary("Dewdrop-2.0")

function TuiRaidTracker:CHAT_MSG_LOOT()

        local player, link, anzahl = deformat(arg1, LOOT_ITEM_MULTIPLE);
        
        if ( not link ) then
            player, link = deformat(arg1, LOOT_ITEM);
            anzahl = 1
        end
        
        if ( not link ) then
            link, anzahl = deformat(arg1, LOOT_ITEM_SELF_MULTIPLE);
            player = UnitName("player");
        end       

        if ( not link ) then
            link = deformat(arg1, LOOT_ITEM_SELF);
            player = UnitName("player");
            anzahl = 1
        end
        
        if (player and link) then
            local _, _, id = string.find(link, "item:(%d+):");
            local itemName, itemLink, itemRarity, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture = GetItemInfo(id);
            
            if self.db.account.settings.minrarity > itemRarity then
              return
            end

            self:Debug(player..":"..itemName.." ("..anzahl..") R:"..itemRarity);          
                        
            table.insert(self.cr.loot,{ 
                player = self:get_player(player), 
                item = id, 
                anzahl = anzahl, 
                date = time(),
                dkp = 0.0
            })
            TuiRaidTracker:UpdateDisplay()
        end    
    
end


function TuiRaidTracker:get_item(itemlink)
  --  TuiRaidTracker:Debug("get_item",itemlink);
    local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture = GetItemInfo(itemlink);

    local info = {};

    info.id = id;
    info.name = itemName;
    info.link = itemLink;
    info.rarity = itemRarity;
    info.icon = itemTexture;
    
    return info
end

function TuiRaidTracker:OnTooltipClick(id)
    
    local db = self.cr.loot[id]
    local item = self:get_item(db.item)
    
    local _,r,g,b = PC:GetRGBPercent("ItemQuality"..item.rarity)
    
    --    TuiRaidTracker:Debug("Click"..debug);
    dewdrop:Open(UIParent,
        'point', "RIGHT",
        'relativePoint', "LEFT",
        'cursorX', true,
        'cursorY', true,
        'children', function(level, value, value_1, value_2, value_3)
            self:Debug("Dewdrop id %d Level %d V:%s V2:%s V3:%s",id,level,value,value_1,value_2);
            if level == 1 then 
                
                dewdrop:AddLine(
                    'text', "["..item.name.."]",
                    'textR',r,'textG',g,'textB',b,
                    'notClickable ', true,
                    'justifyH', "CENTER",
                    'checked', 1,
                    'checkIcon', item.icon,
                    'textHeight', 16,
                    'tooltipFunc', GameTooltip.SetHyperlink,
                    'tooltipArg1', GameTooltip,
                    'tooltipArg2', item.link
                )
                
                dewdrop:AddLine(
                    'text', 'Looter: '..self:get_player(db.player),
                    'isTitle', true
                )
                
                dewdrop:AddLine(
                    'text', 'ndern:',
                    'hasArrow', true,
                    'value', "looter"
                )
            elseif level == 2 then
                if value == "looter" then 
                    local classcount = {}
                    local r,g,b
                    
                    for unit in self.roster:IterateRoster(false) do
                        if classcount[unit.class] then classcount[unit.class] = classcount[unit.class] +1
                        else classcount[unit.class] = 1 end
                    end
                    
                    for k,v in pairs(classcount) do
                        _,r,g,b = PC:GetRGBPercent(k)
                        
                        dewdrop:AddLine(
                            'text', BC[string.gsub(string.lower(k), "^%l", string.upper)],
                            'textR',r,'textG',g,'textB',b,
                            'hasArrow', true,
                            'value', k,
                            'notCheckable', true
                        )
                    end
                    
                    dewdrop:AddLine(
                        'text', 'Manuell',
                        'hasArrow', true,
                        'hasEditBox', true,
                        'editBoxText', self:get_player(db.player),
                        'editBoxFunc', function(id, text)
                                db.player = self:get_player(text)
                                self    :UpdateDisplay()
                            end,
                        'editBoxArg1', id,
                        'notCheckable', true
                    )            
                end
            elseif level == 3 then
                if value_1 == "looter" then
                    for unit in self.roster:IterateRoster(false) do
                        if unit.class == value then
                            dewdrop:AddLine(
                                'text', unit.name,
                                'func', function(id, text)
                                        db.player = self:get_player(text)
                                        self:UpdateDisplay()
                                    end,
                                'arg1', id,
                                'arg2', unit.name,
                                'checked', db.player == self:get_player(unit.name)
                            )
                        end
                    end
                
                end
            end
        end
    )
end

